## mrpt 1.0.2

=== CMakeLists.txt ===
# ----------------------------------------------------------------------------
# Root CMake file for the MRPT libraries and applications
#
#  Run with "cmake ." at the root directory to build the makefiles for
#   the MRPT C++ library, the samples, and the applications. Some scripts
#   for generating the documentation, etc. are also updated.
#
#  For compiling instructions for all compilers and platforms, see
#   http://www.mrpt.org/Building_and_Installing_Instructions
#
#  2007-2012, Jose Luis Blanco <jlblanco@ctima.uma.es>
#
#  NOTE: CMake can be obtained at http://www.cmake.org/
# ----------------------------------------------------------------------------

PROJECT(MRPT)

CMAKE_MINIMUM_REQUIRED(VERSION 2.6.4)
include(cmakemodules/script_init_cmake.cmake REQUIRED)		# CMake tweaks
include(cmakemodules/script_version_number.cmake REQUIRED)	#  Loads the MRPT version number

LIST(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmakemodules") # Directory for CMake scripts

# The root directory for all MRPT libraries/modules:
SET(MRPT_LIBS_ROOT "${CMAKE_SOURCE_DIR}/libs" CACHE INTERNAL "")  # This emulates global vars

# ---------------------------------------------------------------------------
# Create the minimum list of libraries required by an application that
#  uses the MRPT C++ library. This must be passed to "TARGET_LINK_LIBRARIES"
# NOTE: For the compilers MSVC* & Borland most of the libraries are
#        automatically included through "#pragma"'s ;-)
# ---------------------------------------------------------------------------
SET(MRPT_LINKER_LIBS "")
SET(MRPT_LINKER_LIBS_FOR_PKGCONFIG "")

# ----- Useful macros ------
include(cmakemodules/UtilsMacros.cmake REQUIRED)
include(cmakemodules/FilterFileLists.cmake REQUIRED)
include(cmakemodules/MRPTPCHSupport.cmake REQUIRED)
include(cmakemodules/DeclareMRPTLib.cmake REQUIRED)
include(cmakemodules/DeclareAppDependencies.cmake REQUIRED)
# --------------------------

include(cmakemodules/script_detect_unix_arch.cmake REQUIRED)	# Detect machine architecture, on UNIX
include(cmakemodules/script_detect_gcc.cmake REQUIRED)			# Detect GNU GCC version


# ------------------------------------------
# We want libraries to be named "libXXX" 
#  and "libXXX-dbg" in all compilers:
# ------------------------------------------
set(CMAKE_DEBUG_POSTFIX  "-dbg")
IF(MSVC)
	set(MRPT_LIB_PREFIX "lib")  # Libs are: "libXXX"
ENDIF(MSVC)

# In case of Makefiles if the user does not setup CMAKE_BUILD_TYPE, assume it's Release:
if (${CMAKE_GENERATOR} MATCHES ".*Makefiles")
    if("${CMAKE_BUILD_TYPE}" STREQUAL "")
        set(CMAKE_BUILD_TYPE Release)
    endif()
endif()

include(cmakemodules/script_select_app_to_build.cmake REQUIRED)		# Build (or not) some apps:

# ----------------------------------------------------------------------------
# 		CHECK FOR SYSTEM LIBRARIES, OPTIONS, ETC..
# ----------------------------------------------------------------------------

# Detect wordsize:
# -------------------------------------------
IF(CMAKE_SIZEOF_VOID_P EQUAL 8)  # Size in bytes!
	SET(CMAKE_MRPT_WORD_SIZE 64)
ELSE(CMAKE_SIZEOF_VOID_P EQUAL 8)  # Size in bytes!
	SET(CMAKE_MRPT_WORD_SIZE 32)
ENDIF(CMAKE_SIZEOF_VOID_P EQUAL 8)

# Build static or dynamic libs?
# ===================================================
# Default: dynamic libraries:
SET(BUILD_SHARED_LIBS ON CACHE BOOL "Build shared libraries (.dll/.so) instead of static ones (.lib/.a)")
IF(BUILD_SHARED_LIBS)
	SET(CMAKE_MRPT_BUILD_SHARED_LIB "#define MRPT_BUILT_AS_DLL")
	SET(CMAKE_MRPT_BUILD_SHARED_LIB_ONOFF 1)
ELSE(BUILD_SHARED_LIBS)
	SET(CMAKE_MRPT_BUILD_SHARED_LIB "/* #define MRPT_BUILT_AS_DLL */")
	SET(CMAKE_MRPT_BUILD_SHARED_LIB_ONOFF 0)
ENDIF(BUILD_SHARED_LIBS)

# Only for Unix: use pkg-config to find libraries
# ===================================================
INCLUDE(FindPkgConfig OPTIONAL)
IF(PKG_CONFIG_FOUND)
	INCLUDE(FindPkgConfig)
ENDIF(PKG_CONFIG_FOUND)

# Group projects in "folders"
# ===================================================
IF (CMAKE_VERSION VERSION_GREATER "2.8.0")
	SET(ENABLE_SOLUTION_FOLDERS ON CACHE BOOL "Group projects under virtual folders of the compiler IDE (e.g. VisualStudio)")
ENDIF (CMAKE_VERSION VERSION_GREATER "2.8.0")

if (ENABLE_SOLUTION_FOLDERS)
  set_property(GLOBAL PROPERTY USE_FOLDERS ON)
  set_property(GLOBAL PROPERTY PREDEFINED_TARGETS_FOLDER "CMakeTargets")
endif (ENABLE_SOLUTION_FOLDERS)


# Build the ARIA library?
SET(BUILD_ARIA ON CACHE BOOL "Build an embedded version of ActivMedia ARIA library (interface to mobile robots)")
#MARK_AS_ADVANCED(BUILD_ARIA)
IF(BUILD_ARIA)
	SET(CMAKE_MRPT_HAS_ARIA 1)
ELSE(BUILD_ARIA)
	SET(CMAKE_MRPT_HAS_ARIA 0)
ENDIF(BUILD_ARIA)

# Build the xSENS library
# ===================================================
SET(BUILD_XSENS ON CACHE BOOL "Build an embedded version of xSens library (interface to xSens MTi device)")
#MARK_AS_ADVANCED(BUILD_XSENS)

IF(BUILD_XSENS)
	SET(CMAKE_MRPT_HAS_xSENS 1)
	SET(CMAKE_MRPT_HAS_xSENS_SYSTEM 0)
ELSE(BUILD_XSENS)
	SET(CMAKE_MRPT_HAS_xSENS 0)
	SET(CMAKE_MRPT_HAS_xSENS_SYSTEM 0)
ENDIF(BUILD_XSENS)

#-----------------------------------
#  Build the hardware drivers?
#-----------------------------------
SET(BUILD_HWDRIVERS ON CACHE BOOL "Build hardware drivers (library apps/lib_hwdrivers)?.")
MARK_AS_ADVANCED(BUILD_HWDRIVERS)


# GCC only:
# ===================================================
IF(CMAKE_COMPILER_IS_GNUCXX)
	# Enable GCC profiling?
	SET(MRPT_ENABLE_PROFILING OFF CACHE BOOL "Enable profiling in the GCC compiler (Add flags: -g -pg)")
	# Enable libstdc++ parallel mode?
	SET(MRPT_ENABLE_LIBSTD_PARALLEL_MODE OFF CACHE BOOL "Enable parallel mode in libstdc++ (requires GCC 4.2.2+)")
ENDIF(CMAKE_COMPILER_IS_GNUCXX)

# Enable precompiled headers:
# ===================================================
IF(MSVC)
	SET(DEFAULT_VAL_PRECOMP_HDR ON)
ELSE(MSVC)
	SET(DEFAULT_VAL_PRECOMP_HDR OFF)
ENDIF(MSVC)

SET(MRPT_ENABLE_PRECOMPILED_HDRS ${DEFAULT_VAL_PRECOMP_HDR} CACHE BOOL "Enable precompiled headers (thru 'mrpt/LIB.h')")
MARK_AS_ADVANCED(MRPT_ENABLE_PRECOMPILED_HDRS)

# Eigen library plugins:
# ===================================================
include(cmakemodules/script_eigen.cmake REQUIRED)

# MRPT_TRY_START/END blocks
# ===================================================
SET(MRPT_HAS_STACKED_EXCEPTIONS ON CACHE BOOL "Enable MRPT_TRY_START/END blocks (disable it for speed up).")

# Optional MRPT embedded profiler:
# ===================================================
SET(MRPT_ENABLE_EMBEDDED_GLOBAL_PROFILER OFF CACHE BOOL "Enable MRPT embedded profiler.")

# ASSERT_ blocks
# ===================================================
SET(MRPT_HAS_ASSERT ON CACHE BOOL "Enable ASSERT_ statements (disable it for speed up).")

# MSVC only: 
# ===================================================
IF(MSVC)
	# Enable Parallel compilation?
	SET(COMPILE_IN_PARALLEL OFF CACHE BOOL "Enable parallel compilation in Visual Studio")
ENDIF(MSVC)

include(cmakemodules/script_gridmap_options.cmake REQUIRED)			# Enable Intel Threading Building Blocks (TBB) lib?

include(cmakemodules/script_tbb.cmake REQUIRED)         # Enable Intel Threading Building Blocks (TBB) lib?
include(cmakemodules/script_bumblebee.cmake REQUIRED)   # Support for Bumblebee stereo camera (actually: PGR Digiclops/Triclops Windows libraries)
include(cmakemodules/script_phidget.cmake REQUIRED)     # Support for phidget Interface Kit with proximity sensor device :
include(cmakemodules/script_videre_svs.cmake REQUIRED)  # Support for Videre Design stereo camera:
include(cmakemodules/script_ftdi.cmake REQUIRED)        # Check for the FTDI headers (Linux only, in win32 we use built-in header & dynamic DLL load):
include(cmakemodules/script_inotify.cmake REQUIRED)     # Check for the sys/inotify headers (Linux only, in win32 we use the equivalent API for file system monitoring):
include(cmakemodules/script_gl_glut.cmake REQUIRED)     # Check for the GL,GLUT libraries 
include(cmakemodules/script_opencv.cmake REQUIRED)      # Check for the OpenCV libraries (via pkg-config, CMake, with different options)
include(cmakemodules/script_ffmpeg.cmake REQUIRED)      # Check for ffmpeg C libraries: libavcodec, libavutil, libavformat, libswscale
include(cmakemodules/script_wxwidgets.cmake REQUIRED)   # Check for wxWidgets + GL
include(cmakemodules/script_libdc1394.cmake REQUIRED)   # Check for libdc1394-2
include(cmakemodules/script_lib3ds.cmake REQUIRED)      # Check for system lib3ds
include(cmakemodules/script_liblas.cmake REQUIRED)      # Check for the LAS LiDAR format library
include(cmakemodules/script_libtclap.cmake REQUIRED)    # Check for system libtclap
include(cmakemodules/script_zlib.cmake REQUIRED)        # Check for zlib
include(cmakemodules/script_jpeg.cmake REQUIRED)        # Check for jpeg
include(cmakemodules/script_swissrange.cmake REQUIRED)  # Support for SWISSRANGE 3D camera:
include(cmakemodules/script_SIMD.cmake REQUIRED)        # SSE2/SSE3/... optimization options
include(cmakemodules/script_gtest.cmake REQUIRED)       # Unit testing lib
include(cmakemodules/script_clang.cmake REQUIRED)       # clang library (For UTFConvert)
include(cmakemodules/script_national_instruments.cmake REQUIRED)  # NI C library

# ---------------------------------------------------------------------------
#			OPTIONS
#The options for the user when using "cmakesetup" or "ccmake":
# ---------------------------------------------------------------------------
OPTION(MRPT_ALWAYS_CHECKS_DEBUG "Additional checks even in Release" "OFF")
OPTION(MRPT_ALWAYS_CHECKS_DEBUG_MATRICES "Additional checks even in Release (Only in matrix classes)" "OFF")

include(cmakemodules/script_sift_hess.cmake REQUIRED)  # SIFT Hess implementation 

# ---------------------------------------------------------------------------
# Create the minimum list of libraries required by an application that
#  uses the MRPT C++ library. This must be passed to "TARGET_LINK_LIBRARIES"
# NOTE: For the compilers MSVC* & Borland most of the libraries are
#        automatically included through "#pragma"'s ;-)
# ---------------------------------------------------------------------------
IF(NOT MSVC)
	# In Linux, link against librt
	# Jerome Monceaux : 2011/03/08
	# exclude rt from apple osx linking
	IF(UNIX AND NOT APPLE)
		APPEND_MRPT_LIBS(rt)
	ENDIF(UNIX AND NOT APPLE)

	# In Windows, link against ole32 & uuid & oleaut32, etc...
	IF(MINGW)
		APPEND_MRPT_LIBS(ole32 uuid oleaut32 gdi32 winmm setupapi ws2_32)
	ENDIF(MINGW)
ENDIF(NOT MSVC)


SET(CMAKE_MRPT_HAS_GZ_STREAMS ${CMAKE_MRPT_HAS_ZLIB})   # We have gz-streams is we have zlib:


include(cmakemodules/script_kinect.cmake REQUIRED)  # Kinect support in a set of different ways
include(cmakemodules/script_pcl.cmake REQUIRED)     # PCL library
include(cmakemodules/script_suitesparse.cmake REQUIRED)     # SuiteSparse libs


# Save the basic list of libraries (without MRPT-libs):
# -------------------------------------------------------------------------------------
SET(MRPTLIB_LINKER_LIBS ${MRPT_LINKER_LIBS} ${MRPT_FFMPEG_LIBS_TO_LINK})
IF($ENV{VERBOSE})
	MESSAGE(STATUS "MRPTLIB_LINKER_LIBS: ${MRPTLIB_LINKER_LIBS}")
ENDIF($ENV{VERBOSE})

# If we are building .so libs, don't link every program to all the libs:
IF(BUILD_SHARED_LIBS)
	SET(MRPT_LINKER_LIBS "")
ENDIF(BUILD_SHARED_LIBS)


IF(NOT MSVC AND NOT BORLAND)
	FOREACH(_LIB ${ALL_MRPT_LIBS})
		LIST(APPEND MRPT_LINKER_LIBS_FOR_PKGCONFIG "-l${_LIB}")
	ENDFOREACH(_LIB)
ENDIF(NOT MSVC AND NOT BORLAND)

# Save the list of libraries according to the current debug/release build (gcc only)
# -------------------------------------------------------------------------------------
SET(MRPT_LINKER_LIBS_RELorDEB ${MRPT_LINKER_LIBS})

IF(CMAKE_BUILD_TYPE STREQUAL "Debug")
	SET(MRPT_LINKER_LIBS_POSTFIX "${MRPT_DEBUG_POSTFIX}")
ELSE(CMAKE_BUILD_TYPE STREQUAL "Debug")
	SET(MRPT_LINKER_LIBS_POSTFIX "")
ENDIF(CMAKE_BUILD_TYPE STREQUAL "Debug")

# Include Asian fonts in utils::CMRPTCanvas ?

=== apps/CMakeLists.txt ===
# ----------------------------------------------------------------------------
# CMake file. Run with "cmake ." at the root directory.
# ----------------------------------------------------------------------------

INCLUDE(../cmakemodules/AssureCMakeRootFile.cmake) # Avoid user mistake in CMake source directory

# Enumerate all subdirs and process them:
list_subdirectories(LIST_MRPT_APP_DIRS "${MRPT_SOURCE_DIR}/apps")

foreach(dir ${LIST_MRPT_APP_DIRS})
	SET(VAR_NAME "BUILD_APP_${dir}")
	SET(${VAR_NAME} ON CACHE BOOL "Build the app ${dir}")
	MARK_AS_ADVANCED(${VAR_NAME})

	if (${VAR_NAME})
	add_subdirectory(${dir})
	endif (${VAR_NAME})
endforeach(dir)

=== libs/CMakeLists.txt ===
project(ALL_MRPT_LIBS)

# -----------------------------------------------
# 1) Enumerate al subdirectories under "libs/"
# -----------------------------------------------
list_subdirectories(LIST_MRPT_LIB_DIRS "${MRPT_SOURCE_DIR}/libs")

# -----------------------------------------------
# 2) Auto detect which libs are header-only:
# -----------------------------------------------
foreach(dir ${LIST_MRPT_LIB_DIRS})
	set(is_hdr "0")
	if (EXISTS "${MRPT_SOURCE_DIR}/libs/${dir}/include/mrpt/${dir}.h" AND NOT EXISTS "${MRPT_SOURCE_DIR}/libs/${dir}/src/registerAllClasses.cpp")
		set(is_hdr "1")
	endif (EXISTS "${MRPT_SOURCE_DIR}/libs/${dir}/include/mrpt/${dir}.h" AND NOT EXISTS "${MRPT_SOURCE_DIR}/libs/${dir}/src/registerAllClasses.cpp")

	set_property(GLOBAL PROPERTY "mrpt-${dir}_LIB_IS_HEADERS_ONLY" "${is_hdr}")
	#MESSAGE(STATUS "mrpt-${dir}_LIB_IS_HEADERS_ONLY = ${is_hdr}")
endforeach(dir)

# -----------------------------------------------
# 3) Enumerate al subdirectories under "libs/"
# -----------------------------------------------
foreach(dir ${LIST_MRPT_LIB_DIRS})
  add_subdirectory(${dir})
endforeach(dir)

=== otherlibs/CMakeLists.txt ===

INCLUDE(../cmakemodules/AssureCMakeRootFile.cmake) # Avoid user mistake in CMake source directory

IF (CMAKE_MRPT_HAS_WXWIDGETS)
	add_subdirectory(wxThings)
ENDIF (CMAKE_MRPT_HAS_WXWIDGETS)


# This is not needed to be included here, it's done from the main 
# CMakeLists.txt so it can be switched to a system version, if available.
#add_subdirectory(gtest-X.Y.Z)

=== tests/CMakeLists.txt ===
INCLUDE(../cmakemodules/AssureCMakeRootFile.cmake) # Avoid user mistake in CMake source directory

# ----------------------------------------------------------------------------
#   TESTS
# ----------------------------------------------------------------------------
PROJECT(tests)

SET(EXECUTABLE_OUTPUT_PATH "${${PROJECT_NAME}_BINARY_DIR}")


# Fix a "bug" in VS11 (MSVC 2012):
if(MSVC)
	add_definitions(-D_VARIADIC_MAX=10)
endif(MSVC)

# -----------------------------
# Add the "make test" target:
# -----------------------------
ADD_CUSTOM_TARGET(test)
if(ENABLE_SOLUTION_FOLDERS)
	set_target_properties(test PROPERTIES FOLDER "unit tests")
endif(ENABLE_SOLUTION_FOLDERS)

# Tests based on Google gtest:
# -----------------------------

# Include gtest from embeded lib:
IF (NOT CMAKE_MRPT_HAS_GTEST_SYSTEM)
	INCLUDE_DIRECTORIES("${CMAKE_MRPT_GTEST_SRC_DIR}/fused-src/")
ENDIF(NOT CMAKE_MRPT_HAS_GTEST_SYSTEM)

# If using system library, add C++ flags:
IF (NOT "${CMAKE_GTEST_CFLAGS}" STREQUAL "")
	ADD_DEFINITIONS(${CMAKE_GTEST_CFLAGS})
ENDIF (NOT "${CMAKE_GTEST_CFLAGS}" STREQUAL "")


get_property(LST_LIB_TESTS GLOBAL PROPERTY "MRPT_TEST_LIBS")
FOREACH(_TSTLIB ${LST_LIB_TESTS})
	STRING(REGEX REPLACE "mrpt_(.*)" "mrpt-\\1" _TSTLIB_DASH ${_TSTLIB})
	get_property(lstfiles GLOBAL PROPERTY "${_TSTLIB}_UNIT_TEST_FILES")

	#MESSAGE(STATUS "Generating tests for ${_TSTLIB} -> ${_TSTLIB_DASH}")
	#MESSAGE(STATUS "  Files: ${lstfiles}")

	# Test project:
	ADD_EXECUTABLE( test_${_TSTLIB} test_main.cpp ${lstfiles})

	# Add the required libraries for linking:
IF (CMAKE_MRPT_HAS_GTEST_SYSTEM)
	# System vesion:
	TARGET_LINK_LIBRARIES(test_${_TSTLIB} ${MRPT_LINKER_LIBS_RELorDEB} gtest)
ELSE (CMAKE_MRPT_HAS_GTEST_SYSTEM)
	# Own version:
	TARGET_LINK_LIBRARIES(test_${_TSTLIB} ${MRPT_LINKER_LIBS_RELorDEB} mrptgtest) 
	ADD_DEPENDENCIES(test_${_TSTLIB} mrptgtest)  # Assure the MRPT library is updated:
ENDIF (CMAKE_MRPT_HAS_GTEST_SYSTEM)


	set_target_properties(test_${_TSTLIB} PROPERTIES "COMPILE_DEFINITIONS" "MRPT_TEST_LIB=${_TSTLIB}")

	# Deps:
	get_property(lst_deps GLOBAL PROPERTY "${_TSTLIB_DASH}_LIB_DEPS")
	set(lst_deps ${_TSTLIB_DASH} ${lst_deps}) # The order in this list is very important for linking!
	FOREACH(_DEPLIB ${lst_deps})
		# Include dirs:
		STRING(REGEX REPLACE "mrpt-(.*)" "\\1" _DEPLIB_DASH ${_DEPLIB})
		include_directories("${MRPT_LIBS_ROOT}/${_DEPLIB_DASH}/include")

		# Deps:
		ADD_DEPENDENCIES(test_${_TSTLIB} ${_DEPLIB})
		# Linking deps:
		get_property(_LIB_HDRONLY GLOBAL PROPERTY "${_DEPLIB}_LIB_IS_HEADERS_ONLY")
		IF(NOT _LIB_HDRONLY)
			TARGET_LINK_LIBRARIES(test_${_TSTLIB} ${_DEPLIB})
		ENDIF(NOT _LIB_HDRONLY)
	ENDFOREACH(_DEPLIB)
	

	
	# Run it:
	GET_TARGET_PROPERTY(GENERATED_EXE test_${_TSTLIB} LOCATION)
	ADD_CUSTOM_TARGET(run_tests_${_TSTLIB} COMMAND "${GENERATED_EXE}" "${MRPT_SOURCE_DIR}")
	ADD_DEPENDENCIES(run_tests_${_TSTLIB} test_${_TSTLIB})
	ADD_DEPENDENCIES(test run_tests_${_TSTLIB})

if(ENABLE_SOLUTION_FOLDERS)
	set_target_properties(test_${_TSTLIB} PROPERTIES FOLDER "unit tests")
	set_target_properties(run_tests_${_TSTLIB} PROPERTIES FOLDER "unit tests")
endif(ENABLE_SOLUTION_FOLDERS)
	
ENDFOREACH(_TSTLIB)

=== apps/2d-slam-demo/CMakeLists.txt ===
INCLUDE(../../cmakemodules/AssureCMakeRootFile.cmake) # Avoid user mistake in CMake source directory

#-----------------------------------------------------------------
# CMake file for the MRPT application:  2d-slam-demo
#
#  Run with "cmake ." at the root directory
#
#  October 2007, Jose Luis Blanco <jlblanco@ctima.uma.es>
#-----------------------------------------------------------------
PROJECT(slam_demo_2D)

IF(wxWidgets_FOUND)

	# ---------------------------------------------
	# TARGET:
	# ---------------------------------------------
	SET(SRCS 
		slamdemoApp.cpp   slamdemoApp.h
		slamdemoMain.cpp  slamdemoMain.h
		batch_experiments.cpp
		CAboutBox.cpp  CAboutBox.h
		CDlgParams.cpp CDlgParams.h
		CLogView.cpp CLogView.h
	 	../wx-common/CMyRedirector.h
	 )
	 
	IF(WIN32)
		SET(SRCS ${SRCS} resource.rc)
	ENDIF(WIN32)

	# Define the executable target:
	ADD_EXECUTABLE(2d-slam-demo WIN32 ${SRCS})

	SET(TMP_TARGET_NAME "2d-slam-demo")


	

	# Add the required libraries for linking:
	INCLUDE_DIRECTORIES( ${wxWidgets_INCLUDE_DIRS} )
	TARGET_LINK_LIBRARIES(${TMP_TARGET_NAME} ${wxWidgets_LIBRARIES} )
	TARGET_LINK_LIBRARIES(${TMP_TARGET_NAME} ${MRPT_LINKER_LIBS})

	# Dependencies on MRPT libraries:
	#  Just mention the top-level dependency, the rest will be detected automatically, 
	#  and all the needed #include<> dirs added (see the script DeclareAppDependencies.cmake for further details)
	DeclareAppDependencies(${TMP_TARGET_NAME} mrpt-slam mrpt-gui)
	
	DeclareAppForInstall(${TMP_TARGET_NAME})

	AppStartMenuLink(${TMP_TARGET_NAME} "2D KF-SLAM Simulator")   # Add link to the Start menu (in Windows Installable packages)

ELSE(wxWidgets_FOUND)
	# ----------------------------------------------------------------------------------
    # For convenience. When we cannot continue, inform the user
	# ----------------------------------------------------------------------------------
    MESSAGE(STATUS "wxWidgets not found!: **This target will not be included in the Makefiles**")
ENDIF(wxWidgets_FOUND)

=== apps/3DSceneViewer/CMakeLists.txt ===
INCLUDE(../../cmakemodules/AssureCMakeRootFile.cmake) # Avoid user mistake in CMake source directory

#-----------------------------------------------------------------
# CMake file for the MRPT application:  SceneViewer
#
#  Run with "cmake ." at the root directory
#
#  October 2007, Jose Luis Blanco <jlblanco@ctima.uma.es>
#-----------------------------------------------------------------
PROJECT(SceneViewer3D)

IF(wxWidgets_FOUND AND CMAKE_MRPT_HAS_OPENGL_GLUT)

	# ---------------------------------------------
	# TARGET:
	# ---------------------------------------------
	SET(SRCS
		_DSceneViewerApp.cpp _DSceneViewerApp.h
		_DSceneViewerMain.cpp _DSceneViewerMain.h
		CDialogOptions.cpp   CDialogOptions.h
		CAboutBox.cpp        CAboutBox.h
		CDlgCamTracking.cpp  CDlgCamTracking.h
		CDlgPLYOptions.cpp   CDlgPLYOptions.h
		../wx-common/CMyRedirector.h
	)
	IF(WIN32)
		SET(SRCS ${SRCS} resource.rc)
	ENDIF(WIN32)

	INCLUDE_DIRECTORIES("${MRPT_SOURCE_DIR}/otherlibs/wxThings/")
	
	# Define the executable target:
	ADD_EXECUTABLE(SceneViewer3D WIN32 ${SRCS})

	SET(TMP_TARGET_NAME "SceneViewer3D")


	

	# Add the required libraries for linking:
	INCLUDE_DIRECTORIES( ${wxWidgets_INCLUDE_DIRS} )
	TARGET_LINK_LIBRARIES(${TMP_TARGET_NAME} ${wxWidgets_LIBRARIES} )

	TARGET_LINK_LIBRARIES(${TMP_TARGET_NAME} ${MRPT_LINKER_LIBS})

	TARGET_LINK_LIBRARIES(${TMP_TARGET_NAME} mrptwxthings)
	ADD_DEPENDENCIES(${TMP_TARGET_NAME} mrptwxthings)

	# Dependencies on MRPT libraries:
	#  Just mention the top-level dependency, the rest will be detected automatically, 
	#  and all the needed #include<> dirs added (see the script DeclareAppDependencies.cmake for further details)
	DeclareAppDependencies(${TMP_TARGET_NAME} mrpt-opengl mrpt-gui mrpt-maps)

	DeclareAppForInstall(${TMP_TARGET_NAME})

	AppStartMenuLink(${TMP_TARGET_NAME} "Scene Viewer 3D")   # Add link to the Start menu (in Windows Installable packages)

ELSE(wxWidgets_FOUND AND CMAKE_MRPT_HAS_OPENGL_GLUT)
	# ----------------------------------------------------------------------------------
    # For convenience. When we cannot continue, inform the user
	# ----------------------------------------------------------------------------------
    MESSAGE(STATUS "wxWidgets and/or GL/GLUT not found!: **This target will not be included in the Makefiles**")
ENDIF(wxWidgets_FOUND AND CMAKE_MRPT_HAS_OPENGL_GLUT)

=== apps/GridmapNavSimul/CMakeLists.txt ===
INCLUDE(../../cmakemodules/AssureCMakeRootFile.cmake) # Avoid user mistake in CMake source directory

#-----------------------------------------------------------------
# CMake file for the MRPT application:  GridmapNavSimul
#
#  Run with "cmake ." at the root directory
#
#  May 2008, Jose Luis Blanco <jlblanco@ctima.uma.es>
#-----------------------------------------------------------------
PROJECT(GridmapNavSimul)

IF(wxWidgets_FOUND AND CMAKE_MRPT_HAS_OPENGL_GLUT)

	# ---------------------------------------------
	# TARGET:
	# ---------------------------------------------
	SET(SRCS
		gridmapSimulApp.cpp gridmapSimulApp.h
		gridmapSimulMain.cpp gridmapSimulMain.h
		CAboutBox.cpp CAboutBox.h
		)
	IF(WIN32)
		SET(SRCS ${SRCS} resource.rc)
	ENDIF(WIN32)

	# Define the executable target:
	ADD_EXECUTABLE(GridmapNavSimul WIN32 ${SRCS})

	SET(TMP_TARGET_NAME "GridmapNavSimul")

	

	# Add the required libraries for linking:
	INCLUDE_DIRECTORIES( ${wxWidgets_INCLUDE_DIRS} )
	TARGET_LINK_LIBRARIES(${TMP_TARGET_NAME} ${wxWidgets_LIBRARIES} )

	TARGET_LINK_LIBRARIES(${TMP_TARGET_NAME} ${MRPT_LINKER_LIBS})

	IF(UNIX)
		TARGET_LINK_LIBRARIES(${TMP_TARGET_NAME} mrpt-hwdrivers)
	ENDIF(UNIX)

	# Dependencies on MRPT libraries:
	#  Just mention the top-level dependency, the rest will be detected automatically, 
	#  and all the needed #include<> dirs added (see the script DeclareAppDependencies.cmake for further details)
	DeclareAppDependencies(${TMP_TARGET_NAME} mrpt-maps mrpt-hwdrivers)

	DeclareAppForInstall(${TMP_TARGET_NAME})

	AppStartMenuLink(${TMP_TARGET_NAME} "Gridmap navigation dataset generator")   # Add link to the Start menu (in Windows Installable packages)
		

ELSE(wxWidgets_FOUND AND CMAKE_MRPT_HAS_OPENGL_GLUT)
	# ----------------------------------------------------------------------------------
    # For convenience. When we cannot continue, inform the user
	# ----------------------------------------------------------------------------------
    MESSAGE(STATUS "wxWidgets and/or GL/GLUT not found!: **This target will not be included in the Makefiles**")
ENDIF(wxWidgets_FOUND AND CMAKE_MRPT_HAS_OPENGL_GLUT)

=== apps/RawLogViewer/CMakeLists.txt ===
INCLUDE(../../cmakemodules/AssureCMakeRootFile.cmake) # Avoid user mistake in CMake source directory

#-----------------------------------------------------------------
# CMake file for the MRPT application:  RawLogViewer
#
#  Run with "cmake ." at the root directory
#
#  October 2007, Jose Luis Blanco <jlblanco@ctima.uma.es>
#-----------------------------------------------------------------
PROJECT(RawLogViewer)

IF(wxWidgets_FOUND)

	# ---------------------------------------------
	# TARGET:
	# ---------------------------------------------
	SET(SRCS CAboutBox.cpp 	CAboutBox.h
	 CFormEdit.cpp	CFormEdit.h
	 CFormMotionModel.cpp	CFormMotionModel.h
	 CFormPlayVideo.cpp		CFormPlayVideo.h
	 CFormRawMap.cpp		CFormRawMap.h
	 CScanMatching.cpp		CScanMatching.h
	 CFormChangeSensorPositions.cpp CFormChangeSensorPositions.h
	 COdometryParams.cpp 		COdometryParams.h
	 CScanAnimation.cpp			CScanAnimation.h
	 resource.h
	 xRawLogViewerApp.cpp	xRawLogViewerApp.h
	 xRawLogViewerMain.cpp	xRawLogViewerMain.h
	 MyGLCanvas.cpp         MyGLCanvas.h
	 main_gps_ops.cpp
	 main_images_ops.cpp
	 main_imports_exports.cpp
	 main_vodometry.cpp
	 main_artwork.cpp
	 main_convert_ops.cpp
	 CRawlogTreeView.cpp	CRawlogTreeView.h
	 CFormBatchSensorPose.cpp  CFormBatchSensorPose.h
	 CIniEditor.cpp 		CIniEditor.h
	 ../wx-common/CMyRedirector.h
	 )
	 
	IF(WIN32)
		SET(SRCS ${SRCS} resource.rc)
	ENDIF(WIN32)

	INCLUDE_DIRECTORIES("${MRPT_SOURCE_DIR}/otherlibs/wxThings/")

	# Define the executable target:
	ADD_EXECUTABLE(RawLogViewer WIN32 ${SRCS})

	SET(TMP_TARGET_NAME "RawLogViewer")


	

	# Add the required libraries for linking:
	TARGET_LINK_LIBRARIES(${TMP_TARGET_NAME} ${wxWidgets_LIBRARIES} )
	TARGET_LINK_LIBRARIES(${TMP_TARGET_NAME} ${MRPT_LINKER_LIBS})

	TARGET_LINK_LIBRARIES(${TMP_TARGET_NAME} mrptwxthings)
	ADD_DEPENDENCIES(${TMP_TARGET_NAME} mrptwxthings)

	# Dependencies on MRPT libraries:
	#  Just mention the top-level dependency, the rest will be detected automatically, 
	#  and all the needed #include<> dirs added (see the script DeclareAppDependencies.cmake for further details)
	DeclareAppDependencies(${TMP_TARGET_NAME} mrpt-slam mrpt-gui mrpt-topography)
	
	IF(BUILD_STEREOSLAM)
		ADD_DEFINITIONS(-DRAWLOGVIEWER_HAS_STEREOSLAM)
		DeclareAppDependencies(${TMP_TARGET_NAME} mrpt-stereoslam)
	ENDIF(BUILD_STEREOSLAM)	

	DeclareAppForInstall(${TMP_TARGET_NAME})

	AppStartMenuLink(${TMP_TARGET_NAME} "RawLog (dataset) viewer")   # Add link to the Start menu (in Windows Installable packages)


ELSE(wxWidgets_FOUND)
	# ----------------------------------------------------------------------------------
	# For convenience. When we cannot continue, inform the user
	# ----------------------------------------------------------------------------------
    MESSAGE(STATUS "wxWidgets not found!: **This target will not be included in the Makefiles**")
ENDIF(wxWidgets_FOUND)

=== apps/ReactiveNav3D-Demo/CMakeLists.txt ===
INCLUDE(../../cmakemodules/AssureCMakeRootFile.cmake) # Avoid user mistake in CMake source directory

#-----------------------------------------------------------------
# CMake file for the MRPT application:  ReactiveNav3D-Demo
#
#  Run with "cmake ." at the root directory
#
#  Juin 2013, Mariano Jaimez Tarifa <marianojt@uma.es>
#-----------------------------------------------------------------
PROJECT(ReactiveNav3D-Demo)

#MESSAGE(STATUS "Makefile for application: /apps/ReactiveNav3D-Demo ")

# ---------------------------------------------
# TARGET:
# ---------------------------------------------
# Define the executable target:
ADD_EXECUTABLE(ReactiveNav3D-Demo
               ReactiveNav3D_demo_main.cpp
			   ReactiveNav3D_demo.h)

SET(TMP_TARGET_NAME "ReactiveNav3D-Demo")



# Add the required libraries for linking:
TARGET_LINK_LIBRARIES(${TMP_TARGET_NAME} ${MRPT_LINKER_LIBS})

# Dependencies on MRPT libraries:
#  Just mention the top-level dependency, the rest will be detected automatically, 
#  and all the needed #include<> dirs added (see the script DeclareAppDependencies.cmake for further details)
DeclareAppDependencies(${TMP_TARGET_NAME} mrpt-gui mrpt-slam mrpt-reactivenav)

DeclareAppForInstall(${TMP_TARGET_NAME})



#FIND_PACKAGE( MRPT REQUIRED base gui opengl slam maps reactivenav)

=== apps/ReactiveNavigationDemo/CMakeLists.txt ===
INCLUDE(../../cmakemodules/AssureCMakeRootFile.cmake) # Avoid user mistake in CMake source directory

#-----------------------------------------------------------------
# CMake file for the MRPT application:  ReactiveNavigationDemo
#
#  Run with "cmake ." at the root directory
#
#  October 2007, Jose Luis Blanco <jlblanco@ctima.uma.es>
#-----------------------------------------------------------------

PROJECT(ReactiveNavigationDemo)

IF(wxWidgets_FOUND)

	# ---------------------------------------------
	# TARGET:
	# ---------------------------------------------
	SET(SRCS
	 ReactiveNavigationDemoApp.cpp  ReactiveNavigationDemoApp.h
	 ReactiveNavigationDemoMain.cpp  ReactiveNavigationDemoMain.h
	 CIniEditor.cpp  CIniEditor.h
	 DEFAULT_GRIDMAP_DATA.h
	 ../wx-common/CMyRedirector.h
	 )

	IF(WIN32)
		SET(SRCS ${SRCS} resource.rc)
	ENDIF(WIN32)

	# Define the executable target:
	ADD_EXECUTABLE(ReactiveNavigationDemo WIN32 ${SRCS})

	SET(TMP_TARGET_NAME "ReactiveNavigationDemo")


	

	# Add the required libraries for linking:
	TARGET_LINK_LIBRARIES(${TMP_TARGET_NAME} ${wxWidgets_LIBRARIES} )
	TARGET_LINK_LIBRARIES(${TMP_TARGET_NAME} ${MRPT_LINKER_LIBS})

	TARGET_LINK_LIBRARIES(${TMP_TARGET_NAME} mrpt-reactivenav)

	# Dependencies on MRPT libraries:
	#  Just mention the top-level dependency, the rest will be detected automatically, 
	#  and all the needed #include<> dirs added (see the script DeclareAppDependencies.cmake for further details)
	DeclareAppDependencies(${TMP_TARGET_NAME} mrpt-gui mrpt-reactivenav)

	DeclareAppForInstall(${TMP_TARGET_NAME})

	AppStartMenuLink(${TMP_TARGET_NAME} "Reactive navigation demo")   # Add link to the Start menu (in Windows Installable packages)

ELSE(wxWidgets_FOUND)
	# ----------------------------------------------------------------------------------
    # For convenience. When we cannot continue, inform the user
	# ----------------------------------------------------------------------------------
    MESSAGE(STATUS "wxWidgets not found!: **This target will not be included in the Makefiles**")
ENDIF(wxWidgets_FOUND)

=== apps/camera-calib/CMakeLists.txt ===
INCLUDE(../../cmakemodules/AssureCMakeRootFile.cmake) # Avoid user mistake in CMake source directory

#-----------------------------------------------------------------
# CMake file for the MRPT application:  RawLogViewer
#
#  Run with "cmake ." at the root directory
#
#  October 2007, Jose Luis Blanco <jlblanco@ctima.uma.es>
#-----------------------------------------------------------------
PROJECT(camera_calib)

IF(wxWidgets_FOUND)

	# ---------------------------------------------
	# TARGET:
	# ---------------------------------------------
	SET(SRCS 
		camera_calib_guiApp.cpp   camera_calib_guiApp.h
		camera_calib_guiMain.cpp  camera_calib_guiMain.h
		CAboutBox.h  CAboutBox.cpp
		CDlgCalibWizardOnline.cpp  CDlgCalibWizardOnline.h
		MyGLCanvas.cpp MyGLCanvas.h
	 	../wx-common/CMyRedirector.h
	 )
	 
	IF(WIN32)
		SET(SRCS ${SRCS} resource.rc)
	ENDIF(WIN32)

	# Define the executable target:
	ADD_EXECUTABLE(camera-calib WIN32 ${SRCS})

	SET(TMP_TARGET_NAME "camera-calib")


	

	# Add the required libraries for linking:
	INCLUDE_DIRECTORIES( ${wxWidgets_INCLUDE_DIRS} )
	TARGET_LINK_LIBRARIES(${TMP_TARGET_NAME} ${wxWidgets_LIBRARIES} )
	TARGET_LINK_LIBRARIES(${TMP_TARGET_NAME} ${MRPT_LINKER_LIBS})

	# Dependencies on MRPT libraries:
	#  Just mention the top-level dependency, the rest will be detected automatically, 
	#  and all the needed #include<> dirs added (see the script DeclareAppDependencies.cmake for further details)
	DeclareAppDependencies(${TMP_TARGET_NAME} mrpt-vision mrpt-gui mrpt-hwdrivers)
		
	DeclareAppForInstall(${TMP_TARGET_NAME})

	AppStartMenuLink(${TMP_TARGET_NAME} "Camera calibration GUI")   # Add link to the Start menu (in Windows Installable packages)
		
ELSE(wxWidgets_FOUND)
	# ----------------------------------------------------------------------------------
    # For convenience. When we cannot continue, inform the user
	# ----------------------------------------------------------------------------------
    MESSAGE(STATUS "wxWidgets not found!: **This target will not be included in the Makefiles**")
ENDIF(wxWidgets_FOUND)

=== debian/changelog ===
mrpt (1:1.0.2-1ubuntu1) trusty; urgency=medium

  * Build with -O1 optimisation level on armhf, powerpc, ppc64el (LP: #1286343)

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Sat, 01 Mar 2014 01:09:06 +0000

mrpt (1:1.0.2-1build1) trusty; urgency=medium

  * No change rebuild against libav9.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 28 Feb 2014 16:43:34 +0000

mrpt (1:1.0.2-1) unstable; urgency=low

  * New version of upstream sources.
  * Fix FTBFS with newer ffmpeg headers (Closes: #718146)

 -- Jose Luis Blanco (University of Malaga) <joseluisblancoc@gmail.com>  Sat, 03 Aug 2013 12:48:20 +0200

=== debian/control ===
Source: mrpt
Section: science
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Jose Luis Blanco (University of Malaga) <joseluisblancoc@gmail.com>
Build-Depends: debhelper (>= 5), 
               autotools-dev,
               cmake,
               perl,
               zlib1g-dev,
               libjpeg-dev,
               libwxgtk2.8-dev,
               wx2.8-headers,
               libwxbase2.8-dbg,
               libwxgtk2.8-dbg,
               libftdi-dev,
               freeglut3-dev,
               libopencv-dev | libcv-dev, 
               libopencv-dev | libcvaux-dev,
               libopencv-dev | libhighgui-dev,
               doxygen,
               ghostscript,
               graphviz,
               texlive | tetex,
               latexmk,
               texlive-latex-extra,
               texlive-science,
               doxygen-latex | perl,
               subversion,
               libeigen3-dev ,
               libdc1394-22-dev [!hurd-i386],
               libusb-1.0-0-dev [!hurd-i386]
Standards-Version: 3.9.4
Homepage: http://www.mrpt.org/

Package: mrpt-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Mobile Robot Programming Toolkit - Documentation and examples
 The Mobile Robot Programming Toolkit (MRPT) is an extensive, cross-platform,
 and open source C++ library aimed to help robotics researchers to design and
 implement algorithms in the fields of Simultaneous Localization and Mapping 
 (SLAM), computer vision, and motion planning (obstacle avoidance).
 .
 The libraries include classes for easily managing 3D(6D) geometry, 
 probability density functions (pdfs) over many predefined variables (points 
 and poses, landmarks, maps), Bayesian inference (Kalman filters, particle 
 filters), image processing, path planning and obstacle avoidance, 3D 
 visualization of all kind of maps (points, occupancy grids, landmarks,...), 
 Graph-SLAM, Bundle Adjustment, etc.
 Gathering, manipulating and inspecting very large robotic datasets (Rawlogs)
 efficiently is another goal of MRPT, supported by several classes and 
 applications.
 .
 The MRPT is free software and is released under the GPL. 
 .
 This package provides the documentation and examples of MRPT, and the book
  Writing Scientific Applications with the Mobile Robot Programming Toolkit 
  in .ps.gz format.

Package: libmrpt-base1.0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Mobile Robot Programming Toolkit - base library
 The Mobile Robot Programming Toolkit (MRPT) is an extensive, cross-platform,
 and open source C++ library aimed to help robotics researchers to design and
 implement algorithms in the fields of Simultaneous Localization and Mapping 
 (SLAM, Graph-SLAM, Bundle Adjustment), computer vision, and motion planning 
 (obstacle avoidance).
 .
 This package includes the mrpt-base library. 
 . 
 More about MRPT libraries in: http://www.mrpt.org/Libraries

Package: libmrpt-opengl1.0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
	  libmrpt-base1.0
Description: Mobile Robot Programming Toolkit - opengl library
 The Mobile Robot Programming Toolkit (MRPT) is an extensive, cross-platform,
 and open source C++ library aimed to help robotics researchers to design and
 implement algorithms in the fields of Simultaneous Localization and Mapping 
 (SLAM, Graph-SLAM, Bundle Adjustment), computer vision, and motion planning 
 (obstacle avoidance).
 .
 This package includes the mrpt-opengl library. 
 . 
 More about MRPT libraries in: http://www.mrpt.org/Libraries


Package: libmrpt-gui1.0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
	  libmrpt-opengl1.0
Description: Mobile Robot Programming Toolkit - gui library
 The Mobile Robot Programming Toolkit (MRPT) is an extensive, cross-platform,
 and open source C++ library aimed to help robotics researchers to design and
 implement algorithms in the fields of Simultaneous Localization and Mapping 
 (SLAM, Graph-SLAM, Bundle Adjustment), computer vision, and motion planning 
 (obstacle avoidance).
 .
 This package includes the mrpt-gui library. 
 . 
 More about MRPT libraries in: http://www.mrpt.org/Libraries

Package: libmrpt-obs1.0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
	  libmrpt-opengl1.0
Description: Mobile Robot Programming Toolkit - obs library
 The Mobile Robot Programming Toolkit (MRPT) is an extensive, cross-platform,
 and open source C++ library aimed to help robotics researchers to design and
 implement algorithms in the fields of Simultaneous Localization and Mapping 
 (SLAM, Graph-SLAM, Bundle Adjustment), computer vision, and motion planning 
 (obstacle avoidance).
 .
 This package includes the mrpt-obs library. 
 . 
 More about MRPT libraries in: http://www.mrpt.org/Libraries

Package: libmrpt-maps1.0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
	  libmrpt-obs1.0
Description: Mobile Robot Programming Toolkit - maps library
 The Mobile Robot Programming Toolkit (MRPT) is an extensive, cross-platform,
 and open source C++ library aimed to help robotics researchers to design and
 implement algorithms in the fields of Simultaneous Localization and Mapping 
 (SLAM, Graph-SLAM, Bundle Adjustment), computer vision, and motion planning 
 (obstacle avoidance).
 .
 This package includes the mrpt-maps library. 
 . 
 More about MRPT libraries in: http://www.mrpt.org/Libraries


Package: libmrpt-hwdrivers1.0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
	  libmrpt-obs1.0,
	  libmrpt-gui1.0
Description: Mobile Robot Programming Toolkit - hwdrivers library
 The Mobile Robot Programming Toolkit (MRPT) is an extensive, cross-platform,
 and open source C++ library aimed to help robotics researchers to design and
 implement algorithms in the fields of Simultaneous Localization and Mapping 
 (SLAM, Graph-SLAM, Bundle Adjustment), computer vision, and motion planning 
 (obstacle avoidance).
 .
 This package includes the mrpt-hwdrivers library. 
 . 
 More about MRPT libraries in: http://www.mrpt.org/Libraries


Package: libmrpt-vision1.0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
	  libmrpt-obs1.0
Description: Mobile Robot Programming Toolkit - vision library
 The Mobile Robot Programming Toolkit (MRPT) is an extensive, cross-platform,
 and open source C++ library aimed to help robotics researchers to design and
 implement algorithms in the fields of Simultaneous Localization and Mapping 
 (SLAM, Graph-SLAM, Bundle Adjustment), computer vision, and motion planning 
 (obstacle avoidance).
 .
 This package includes the mrpt-vision library. 
 . 
 More about MRPT libraries in: http://www.mrpt.org/Libraries

Package: libmrpt-scanmatching1.0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
          libmrpt-base1.0
Description: Mobile Robot Programming Toolkit - scanmatching library
 The Mobile Robot Programming Toolkit (MRPT) is an extensive, cross-platform,
 and open source C++ library aimed to help robotics researchers to design and
 implement algorithms in the fields of Simultaneous Localization and Mapping
 (SLAM, Graph-SLAM, Bundle Adjustment), computer vision, and motion planning 
 (obstacle avoidance).
 .
 This package includes the mrpt-scanmatching library.
 .
 More about MRPT libraries in: http://www.mrpt.org/Libraries


Package: libmrpt-topography1.0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
	  libmrpt-scanmatching1.0,
	  libmrpt-obs1.0
Description: Mobile Robot Programming Toolkit - topography library
 The Mobile Robot Programming Toolkit (MRPT) is an extensive, cross-platform,
 and open source C++ library aimed to help robotics researchers to design and
 implement algorithms in the fields of Simultaneous Localization and Mapping 
 (SLAM, Graph-SLAM, Bundle Adjustment), computer vision, and motion planning 
 (obstacle avoidance).
 .
 This package includes the mrpt-topography library. 
 . 
 More about MRPT libraries in: http://www.mrpt.org/Libraries


Package: libmrpt-detectors1.0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
	  libmrpt-maps1.0,
	  libmrpt-vision1.0,
	  libmrpt-gui1.0
Description: Mobile Robot Programming Toolkit - detectors library
 The Mobile Robot Programming Toolkit (MRPT) is an extensive, cross-platform,
 and open source C++ library aimed to help robotics researchers to design and
 implement algorithms in the fields of Simultaneous Localization and Mapping 
 (SLAM, Graph-SLAM, Bundle Adjustment), computer vision, and motion planning 
 (obstacle avoidance).
 .
 This package includes the mrpt-detectors library. 
 . 
 More about MRPT libraries in: http://www.mrpt.org/Libraries


Package: libmrpt-slam1.0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
	  libmrpt-maps1.0,
	  libmrpt-vision1.0,
	  libmrpt-scanmatching1.0
Description: Mobile Robot Programming Toolkit - slam library
 The Mobile Robot Programming Toolkit (MRPT) is an extensive, cross-platform,
 and open source C++ library aimed to help robotics researchers to design and
 implement algorithms in the fields of Simultaneous Localization and Mapping 
 (SLAM, Graph-SLAM, Bundle Adjustment), computer vision, and motion planning 
 (obstacle avoidance).
 .
 This package includes the mrpt-slam library. 
 . 
 More about MRPT libraries in: http://www.mrpt.org/Libraries


Package: libmrpt-reactivenav1.0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
	  libmrpt-maps1.0
Description: Mobile Robot Programming Toolkit - reactivenav library
 The Mobile Robot Programming Toolkit (MRPT) is an extensive, cross-platform,
 and open source C++ library aimed to help robotics researchers to design and
 implement algorithms in the fields of Simultaneous Localization and Mapping 
 (SLAM, Graph-SLAM, Bundle Adjustment), computer vision, and motion planning 
 (obstacle avoidance).
 .
 This package includes the mrpt-reactivenav library. 
 . 
 More about MRPT libraries in: http://www.mrpt.org/Libraries


Package: libmrpt-hmtslam1.0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
	  libmrpt-slam1.0
Description: Mobile Robot Programming Toolkit - hmtslam library
 The Mobile Robot Programming Toolkit (MRPT) is an extensive, cross-platform,
 and open source C++ library aimed to help robotics researchers to design and
 implement algorithms in the fields of Simultaneous Localization and Mapping 
 (SLAM, Graph-SLAM, Bundle Adjustment), computer vision, and motion planning 
 (obstacle avoidance).
 .
 This package includes the mrpt-hmtslam library. 
 . 
 More about MRPT libraries in: http://www.mrpt.org/Libraries


Package: libmrpt-kinematics1.0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
	  libmrpt-opengl1.0
Description: Mobile Robot Programming Toolkit - kinematics library
 The Mobile Robot Programming Toolkit (MRPT) is an extensive, cross-platform,
 and open source C++ library aimed to help robotics researchers to design and
 implement algorithms in the fields of Simultaneous Localization and Mapping 
 (SLAM, Graph-SLAM, Bundle Adjustment), computer vision, and motion planning 
 (obstacle avoidance).
 .
 This package includes the mrpt-kinematics library. 
 . 
 More about MRPT libraries in: http://www.mrpt.org/Libraries


Package: libmrpt-dev
Section: libdevel
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libeigen3-dev,
         libmrpt-base1.0 (= ${binary:Version}),
         libmrpt-detectors1.0 (= ${binary:Version}),
         libmrpt-gui1.0 (= ${binary:Version}),
         libmrpt-hmtslam1.0 (= ${binary:Version}),
         libmrpt-hwdrivers1.0 (= ${binary:Version}),
         libmrpt-kinematics1.0 (= ${binary:Version}),
         libmrpt-maps1.0 (= ${binary:Version}),

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Makefile for MRPT Debian package.

# Uncomment this to turn on verbose mode.
export DH_DEBUG=1
export DH_VERBOSE=1

include /usr/share/dpkg/architecture.mk
ifneq (,$(filter armhf powerpc ppc64el,$(DEB_HOST_ARCH)))
DPKG_EXPORT_BUILDFLAGS    = yes
DEB_CFLAGS_MAINT_APPEND   = -O1
DEB_CXXFLAGS_MAINT_APPEND = -O1
DEB_CFLAGS_MAINT_STRIP    = -O2 -O3
DEB_CXXFLAGS_MAINT_STRIP  = -O2 -O3
CMAKE_BUILD_TYPE=None
else
CMAKE_BUILD_TYPE=Release
endif
include /usr/share/dpkg/default.mk

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
         NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
         MAKEFLAGS += -j$(NUMJOBS)
endif

config.status: CMakeLists.txt
	dh_testdir
	# Add here commands to configure the package and install it into debian/mrpt-*
	cmake . \
		-DCMAKE_HOST=$(DEB_HOST_GNU_TYPE) \
		-DCMAKE_BUILD=$(DEB_BUILD_GNU_TYPE) \
		-DCMAKE_BUILD_TYPE=$(CMAKE_BUILD_TYPE)  \
		-DCMAKE_INSTALL_PREFIX=$(CURDIR)/debian/ \
		-DCMAKE_CONFIGURE_LDFLAGS="$(LDFLAGS)" \
		-DCMAKE_MRPT_USE_DEB_POSTFIXS="1" \
		-DCMAKE_MRPT_IS_RPM_PACKAGE="0" \
		-DCMAKE_C_FLAGS="$(CFLAGS) $(CPPFLAGS)" \
		-DCMAKE_CXX_FLAGS="$(CXXFLAGS) $(CPPFLAGS)" \
		-DCMAKE_VERBOSE_MAKEFILE=ON \
		 

build: build-arch build-indep

build-arch: build-stamp
build-indep: build-stamp

build-stamp:  config.status
	dh_testdir

	touch $@

distclean:
    # Nothing to do (do not remove this line!)

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp 

	# Add here commands to clean up after the build process.
	rm -f config.sub config.guess

	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_clean -k 
	dh_installdirs

	# Create mrpt documentation
	VERBOSE=1 make documentation_html
	VERBOSE=1 make documentation_performance_html
	# Create man pages:
	make man_pages_all
	# Compile manual(s):
	make documentation_psgz_guides || echo "*** Ignoring failed manual build! ***"
	# Build all
	$(MAKE) VERBOSE=1
	# Run tests
	make test || echo "*** Ignoring failed tests! ***"

	# Install
	$(MAKE) install
	
	# Move all the ".so" files to the proper place: the -dev package:
	mkdir -p $(CURDIR)/debian/libmrpt-dev/usr/lib/
	find $(CURDIR)/debian/ -name "*.so" | grep -v 'libmrpt-dev' | xargs -I FIL mv -f FIL $(CURDIR)/debian/libmrpt-dev/usr/lib/

	# DEBUG PACKAGES -------------	
	#./configure MRPT_IS_DEB_PACKAGE=1 --prefix=$(CURDIR)/debian/ CMAKE_MRPT_USE_DEB_POSTFIXS="1" --buildtype=Debug
	# Build libs only
	cmake . -DCMAKE_BUILD_TYPE=Debug -DBUILD_APPLICATIONS=OFF
	$(MAKE) VERBOSE=1 

	# Install
	$(MAKE) install

	# Move all the "-dbg.so" files to the proper place: the -dev package:
	mkdir -p $(CURDIR)/debian/libmrpt-dbg/usr/lib/
	find $(CURDIR)/debian/ -name "*-dbg.so*" | grep -v 'libmrpt-dev' | grep -v 'libmrpt-dbg' | xargs -I FIL mv -f FIL $(CURDIR)/debian/libmrpt-dbg/usr/lib/

	# Create Lintian overrides:
	mkdir -p $(CURDIR)/debian/libmrpt-dbg/usr/share/lintian/overrides/
	echo "libmrpt-dbg: non-dev-pkg-with-shlib-symlink" > $(CURDIR)/debian/libmrpt-dbg/usr/share/lintian/overrides/libmrpt-dbg
	echo "libmrpt-dbg: package-name-doesnt-match-sonames" >> $(CURDIR)/debian/libmrpt-dbg/usr/share/lintian/overrides/libmrpt-dbg

	
# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs 
	dh_installdocs
	dh_installmenu
	dh_installmime -p mrpt-core
	dh_installman -p mrpt-apps $(CURDIR)/man-pages/*.1*
	# Register .desktop files with a MIME type:
#	dh_desktop -p mrpt-apps
	dh_link
	#dh_strip -plibmrpt-dbg --dbg-package=libmrpt-dbg
	dh_strip --exclude=-dbg
	dh_compress
	dh_fixperms
	dh_makeshlibs -a
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

=== debian/watch ===
version=3
http://archive.mrpt.org/debian-packages/mrpt-(.+)\.tar\.gz
